<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "organization_feature".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "OrganizationFeature".
 *
 * Columns in table "organization_feature" available as properties of the model,
 * followed by relations of table "organization_feature" available as properties of the model.
 *
 * @property integer $id
 * @property integer $organization_id
 * @property integer $feature_id
 * @property integer $provider_id
 * @property integer $practice_id
 * @property integer $active
 * @property string $date_added
 * @property string $date_updated
 *
 * @property Feature $feature
 * @property Organization $organization
 * @property Practice $practice
 * @property Provider $provider
 */
abstract class BaseOrganizationFeature extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'organization_feature';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'OrganizationFeature|OrganizationFeatures', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('organization_id, feature_id', 'required'),
            array('organization_id, feature_id, provider_id, practice_id, active', 'numerical', 'integerOnly' => true),
            array('date_added, date_updated', 'safe'),
            array('provider_id, practice_id, active, date_added, date_updated', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, organization_id, feature_id, provider_id, practice_id, active, date_added, date_updated', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'feature' => array(self::BELONGS_TO, 'Feature', 'feature_id'),
            'organization' => array(self::BELONGS_TO, 'Organization', 'organization_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'organization_id' => Yii::t('app', 'Organization ID'),
            'feature_id' => Yii::t('app', 'Feature'),
            'provider_id' => Yii::t('app', 'Provider'),
            'practice_id' => Yii::t('app', 'Practice'),
            'active' => Yii::t('app', 'Active'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'feature' => Yii::t('app', 'Feature'),
            'organization' => Yii::t('app', 'Organization Name'),
            'practice' => Yii::t('app', 'Practice'),
            'provider' => Yii::t('app', 'Provider'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('organization_id', $this->organization_id);
        $criteria->compare('feature_id', $this->feature_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('active', $this->active);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
